//+------------------------------------------------------------------+
//|                                                      RSIBars.mq4 |
//|                                                      nicholishen |
//|                            http://www.reddit.com/u/nicholishenFX |
//+------------------------------------------------------------------+
#property copyright "nicholishen"
#property link      "http://www.reddit.com/u/nicholishenFX"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#include "RsiBar.mqh"

input int  rsi_period = 14;

CList list;
//+------------------------------------------------------------------+
int OnInit()
{
   ChartSetInteger(0,CHART_SCALE,3);
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   CRates rates;
   if(prev_calculated==0)
   {
      for(int i=0;i<rates_total&&i<3000;i++)
         list.Add(new CRsiBar(i,rsi_period,&rates));
   }
   else
   {
      if(rates_total==prev_calculated)
      {
         CRsiBar *bar = list.GetFirstNode();
         bar.Update(&rates);
      }
      else
         list.Insert(new CRsiBar(0,rsi_period,&rates),0);
   }
   return(rates_total);
}
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   list.Clear();
   ObjectsDeleteAll(0,"__RsiBar__");
}